const INF = 1000000000;
      modulo = 10005;

type node = record
	index : longint;
	value : extended;
end;

type node2 = record
        value : extended;
        index : longint;
end;

type nodeRecord = record
	index : longint;
	value : longint;
end;

var n, m, k, i, j, cnt: longint;
    l, r, middle : extended;
    iter : longint;
    ok : boolean;
    a : array[0 .. 10000 + 100] of extended;
    num, ans, answer, p, best : array[0 .. 10000 + 100] of longint;
    rsq : array[0 .. 40000 + 100] of nodeRecord;
    b : array[0 .. 10000 + 111] of node2;


procedure swapl(var t, y : longint);
var u : longint;
begin
 u := t; t := y; y := u;
end;

procedure swape(var t, y : extended);
var u : extended;
begin
 u := t; t := y; y := u;
end;

function less(a : extended; b : longint; c : extended; d : longint) : boolean;
begin
 if (abs(a - c) < 1e-9) then
  begin
   if (b < d) then less := true else less := false;
  end else
  begin
   if (a < c) then less := true else less := false;
  end;
end;

procedure sort(l, r : longint);
var i, j, num: longint;
    mid : extended;
begin
 i := l;
 j := r;
 mid := b[(l + r) div 2].value;
 num := b[(l + r) div 2].index;
 repeat
  while less(b[i].value, b[i].index, mid, num) do i := i + 1;
  while less(mid, num, b[j].value, b[j].index) do j := j - 1;
  if (i <= j) then
   begin
    swape(b[i].value, b[j].value);
    swapl(b[i].index, b[j].index);
    i := i + 1;
    j := j - 1;
   end;
 until i > j;
 if (l < j) then sort(l, j);
 if (i < r) then sort(i, r);
end;

procedure replace(pos : longint; val : longint);
var ind, pos2 : longint;
begin
 pos2 := pos;
 pos := pos + 1;
 while (pos <= n + 1) do 
  begin
   if (val > rsq[pos].value) then
    begin
     rsq[pos].value := val;
     rsq[pos].index := pos2;
    end;
   pos := 2 * pos - (pos and (pos - 1));
  end;
end;

function getMax(r : longint) : nodeRecord;
var i, j, ind, answer : longint;
    res : nodeRecord;
begin
 ind := -1;
 r := r + 1;
 answer := -INF;
 while (r >= 1) do
  begin
   if (rsq[r].value > answer) then
    begin
     answer := rsq[r].value;
     ind := rsq[r].index;
    end;
   r := r and (r - 1);
  end;
 res.index := ind;
 res.value := answer;
 getMax := res;
end;


function f(mid : extended; y : longint) : boolean;
var i, curPos, l, r, curInd : longint;
    curMax : nodeRecord;
begin
 for i := 0 to n + 1 do rsq[i].value := -INF;
 b[0].value := 0;
 b[0].index := 0;
 for i := 1 to n do b[i].value := a[i] - mid;
 for i := 1 to n do b[i].value := b[i - 1].value + b[i].value;
 for i := 0 to n do b[i].index := i;
 for i := 0 to n do best[i] := -1;
 best[0] := 0;
 sort(0, n);
                                             
 for i := 0 to n do
  begin
   curInd := b[i].index;
   if (curInd - m >= 0) then
    begin
     curMax := getMax(curInd - m);
     if (curMax.value >= 0) then
      begin
       best[curInd] := curMax.value + 1;
       p[curInd] := curMax.index;
      end;
    end;
     if (best[curInd] >= 0) then
      replace(curInd, best[curInd]);
                                
  end;
  if (best[n] >= k) then
  begin
   cnt := k;
   r := n;
   while (cnt >= 2) do
    begin
     ans[cnt] := r - p[r];
     r := p[r];
     cnt := cnt - 1;
    end;
    ans[1] := r;
   f := true;
  end else f := false;
end;

begin
 assign(input, 'vuttsis.txt'); reset(input);
 assign(output, 'vuttval.txt'); rewrite(output);
 readln(n, m, k);
 for i := 1 to n do read(a[i]);
 l := 0;
 r := 1e9;
 for iter := 1 to 56 do
  begin
   middle := (l + r) / 2.0;
   if f(middle, 0) then l := middle else r := middle;
  end;
 ok := f(l, 1);
 for i := 1 to k - 1 do write(ans[i],' ');
 writeln(ans[k]);
end.
