# sisendi korrektsuse kontrollija

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

(n, m, k) = map(int, fi.readline().strip().split())
if 2 > n or n > 100000:
	sys.exit('N out of range')
if 0 > m or m > 100000:
	sys.exit('M out of range')
if 0 > k or k > 1000000000 or k > n * (n - 1) / 2 - m:
	sys.exit('K out of range')
fo.write('{0} {1} {2}\n'.format(n, m, k))

r = set()
for i in range(m):
	(x, y) = map(int, fi.readline().strip().split())
	if 1 > x or x > n:
		sys.exit('X[{0}] out of range'.format(1 + i))
	if 1 > y or y > n:
		sys.exit('Y[{0}] out of range'.format(1 + i))
	if x == y:
		sys.exit('X[{0}] == Y[{0}]'.format(1 + i, 1 + i))
	if (x, y) in r:
		sys.exit('duplicate road ({0}, {1}) '.format(x, y))
	r.add((x, y))
	r.add((y, x))
	fo.write('{0} {1}\n'.format(x, y))

fi.close()
fo.close()
