const INF = 1000000000;
      modulo = 20000;

type node = record
	index : longint;
	value : extended;
end;

type node2 = record
        value : extended;
        index : longint;
end;

type nodeRecord = record
	index : longint;
	value : longint;
end;

var n, m, k, i, j, cnt: longint;
    l, r, middle : extended;
    iter : longint;
    ok : boolean;
    a : array[0 .. 10000 + 100] of extended;
    num, ans, answer, p : array[0 .. 10000 + 100] of longint;
    rsq : array[0 .. 40000 + 100] of nodeRecord;
    b : array[0 .. 10000 + 111] of node2;


procedure swapl(var t, y : longint);
var u : longint;
begin
 u := t; t := y; y := u;
end;

procedure swape(var t, y : extended);
var u : extended;
begin
 u := t; t := y; y := u;
end;

function less(a : extended; b : longint; c : extended; d : longint) : boolean;
begin
 if (abs(a - c) < 1e-9) then
  begin
   if (b < d) then less := true else less := false;
  end else
  begin
   if (a < c) then less := true else less := false;
  end;
end;

procedure sort(l, r : longint);
var i, j, num: longint;
    mid : extended;
begin                    
 i := l;
 j := r;
 mid := b[(l + r) div 2].value;
 num := b[(l + r) div 2].index;
 repeat
  while b[i].value < mid do i := i + 1;
  while mid < b[j].value do j := j - 1;
  if (i <= j) then
   begin
    swape(b[i].value, b[j].value);
    swapl(b[i].index, b[j].index);
    i := i + 1;
    j := j - 1;
   end;
 until i > j;
 if (l < j) then sort(l, j);
 if (i < r) then sort(i, r);
end;

procedure replace(pos : longint; val : longint);
var ind : longint;
begin
 ind := pos;
 pos := pos + 1; //!!!!!!
 pos := pos + modulo - 1;
 rsq[pos].value := val;
 rsq[pos].index := ind;
 pos := pos div 2;
 while (pos > 0) do
  begin
   if (rsq[pos + pos].value > rsq[pos + pos + 1].value) then
    begin
     rsq[pos] := rsq[pos + pos];
    end else
    begin
     rsq[pos] := rsq[pos + pos + 1];
    end;
   pos := pos div 2;
  end;
end;

function getMax(l, r : longint) : nodeRecord;
var i, j, ind, answer : longint;
    res : nodeRecord;
begin
 l := l + 1;
 r := r + 1;
 i := l + modulo - 1;
 j := r + modulo - 1;
 answer := -INF;
 ind := 0;
 while (i <= j) do
  begin
   if odd(i) then if (rsq[i].value > answer) then begin answer := rsq[i].value; ind := rsq[i].index; end;
   if not odd(j) then if (rsq[j].value > answer) then begin answer := rsq[j].value; ind := rsq[j].index; end;
   i := (i + 1) div 2;
   j := (j - 1) div 2;
  end;
 res.index := ind;
 res.value := answer;
 getMax := res;
end;


function f(mid : extended; y : longint) : boolean;
var i, curPos, l, r : longint;
    curMax : nodeRecord;
begin
 fillchar(rsq, sizeof(rsq), 0);
 replace(0, 0);
 for i := 1 to n do replace(i, -INF);
 for i := 1 to n do b[i].value := a[i] - mid;
 for i := 1 to n do b[i].value := b[i - 1].value + b[i].value;
 for i := 1 to n do b[i].index := i;
 sort(1, n);                                                       
 for i := 1 to n do b[i].value := a[i] - mid;
 for i := 1 to n do b[i].value := b[i - 1].value + b[i].value;
 for i := 1 to n do num[i] := b[i].index;
 for i := 1 to n do
  begin
   curPos := num[i];
   if (num[i] < m) then continue;
   if (b[num[i]].value < 0) then continue;
   l := 0;
   r := num[i] - m;
   curMax := getMax(l, r);
   replace(curPos, curMax.value + 1);
   p[curPos] := curMax.index;
  end;
 if (getMax(n, n).value >= k) then
  begin
   cnt := k;
   r := n;
   while (cnt >= 2) do
    begin
     ans[cnt] := r - p[r];
     r := p[r];
     cnt := cnt - 1;
    end;
    ans[1] := r;
   f := true;
  end else f := false;
end;

begin
 assign(input, 'vuttsis.txt'); reset(input);
 assign(output, 'vuttval.txt'); rewrite(output);
 readln(n, m, k);
 for i := 1 to n do read(a[i]);
 l := 0;
 r := 1e9;
 for iter := 1 to 54 do
  begin
   middle := (l + r) / 2.0;
   if f(middle, 0) then l := middle else r := middle;
  end;
 ok := f(l, 1);
 for i := 1 to k - 1 do write(ans[i],' ');
 writeln(ans[k]);
end.
